%define oname	pycrypto
%global __exclude_provides_from %{python_sitearch}/.*\\.so|%{python3_sitearch}/.*\\.so

Summary:	Python interface to various crypto algorithms and protocols
Name:		python-%{oname}
Version:	2.6.1
Release:	%mkrel 3
Source0:	http://ftp.dlitz.net/pub/dlitz/crypto/pycrypto/%{oname}-%{version}.tar.xz
Patch0:		pycrypto-libm.patch
Patch1:		CVE-2013-7459.patch
Patch2:		python-crypto-2.4-optflags.patch
Patch3:		pycrypto-2.6.1-CVE-2018-6594.patch
License:	Public Domain
Group:		Development/Python
URL:		http://www.pycrypto.org
Obsoletes:  python-crypto
Provides:   python-crypto = %version-%release
Provides:   pycrypto = %version-%release

%description
The Toolkit is a collection of cryptographic algorithms and protocols,
implemented for use from Python. Among the contents of the package:

 * Hash functions: MD2, MD4, RIPEMD.
 * Block encryption algorithms: AES, ARC2, Blowfish, CAST, DES, Triple-
   DES, IDEA, RC5.
 * Stream encryption algorithms: ARC4, simple XOR.
 * Public-key algorithms: RSA, DSA, ElGamal, qNEW.
 * Protocols: All-or-nothing transforms, chaffing/winnowing.
 * Miscellaneous: RFC1751 module for converting 128-key keys into a set
   of English words, primality testing.
 * Some demo programs (currently all quite old and outdated).

%package -n python3-%{oname}
Summary:	Python 3 interface to various crypto algorithms and protocols
Group:		Development/Python
Obsoletes:  python3-crypto
Provides:   python3-crypto = %version-%release
Provides:   pycrypto3 = %version-%release

%description -n python3-%{oname}
PyCrypto is a collection of both secure hash functions (such as MD5 and
SHA), and various encryption algorithms (AES, DES, RSA, ElGamal, etc.).

This is the Python 3 build of the package.

%prep
%setup -q -n %{oname}-%{version}
%patch0 -p0 -b .libm
%patch1 -p1
%patch2 -p1
%patch3 -p0


%build
%global optflags %{optflags} -fno-strict-aliasing
%py2_build
%py3_build


%install
%py2_install
%py3_install

# Remove group write permissions on shared objects
find %{buildroot}%{python2_sitearch} -name '*.so' -exec chmod -c g-w {} \;
find %{buildroot}%{python3_sitearch} -name '*.so' -exec chmod -c g-w {} \;


%files
%doc ChangeLog README COPYRIGHT TODO
%{python2_sitearch}/Crypto/
%{python2_sitearch}/*.egg-info

%files -n python3-%{oname}
%doc ChangeLog README COPYRIGHT TODO
%{python3_sitearch}/Crypto/
%{python3_sitearch}/*.egg-info

%changelog
* Sun Aug 14 2022 TerryN <terryn94 at gmail.com> 2.6.1-3pclos2022
- rebuild for python 3.10

* Sat Jul 06 2019 tex 2.6.1-2pclos2019
- update and fix obsolete and deps

